/***************************************************************************
*                 _                                _                       *
*                /_\         Chess Board          /_\                      *
*                \_/      -------------------     \_/                      *
*                /_\             Move             /_\                      *
*                |_|      -------------------     |_|                      *
*               /___\      GNU GPL Version 2     /___\                     *
*                                                                          *
***************************************************************************/
/* Header Files */
#include "move.h"
/* Secure */
#define ENGINE
/* Network Definitions */
socket_t tcpsock;
socket_t tcpsock2; 

#ifdef ENGINE
/* Window */
static WINDOW *winF;
static WINDOW *winE;
/* File Open */
FILE *gnuchess;
/* Computer Move */
const char *cmove = ". ";
const char *emove = ". ... ";

/*---------------------------------------------------------------------------*/

/* GNU Engine */
void cbengine(char *nmove, char *chess)
{
	/* Window Box */
	winF = newwin(11,76,13,2);
	winE = newwin(9,74,14,3);
	box(winF,ACS_VLINE,ACS_HLINE);
	scrollok(winE,TRUE);

	/* File Open */
	gnuchess=fopen("/var/log/cboard/engine","r+");

	/* GNU Chess */
	while(fread(position,1, sizeof(position),gnuchess))
	{	
		if(chess[2])
		{
			bmove = strstr(position,cmove);
			sscanf(bmove,". %s",nmove);
		}
		if(chess[1])
		{
			bmove = strstr(position,emove);
			sscanf(bmove,". ... %s",nmove);
		}
		wprintw(winE,"%s", position);
	}

	/* Windows Refresh */
	touchwin(stdscr);
	refresh();
	wrefresh(winF);
	wrefresh(winE);
}
#endif

/*---------------------------------------------------------------------------*/

/* Network / send() / recv() */		
void cbnetwork(char *nmove,char *chess,char *player)
{	
	/* Chess Player */
	if(player[1])
	{
		mvprintw(4,37,"White:");
		mvprintw(5,37,"------");
		mvprintw(6,37," ");
	}
	if(player[8])
	{
		mvprintw(4,37,"Black:");
		mvprintw(5,37,"------");
		mvprintw(6,37," ");
	}
	
	/* White */
	if(chess[1] && player[1])
	{
		getnstr(nmove, MOV);
	}
	/* Black */
	else if(chess[2] && player[8])
	{
		getnstr(nmove, MOV);
	}
	/* White or Black */
	else if(chess[3] && (player[1] || player[8]))
	{
		getnstr(nmove, MOV);
	}
	
	/* Server */
	else if(chess[4])
	{
		if(player[1])
		{	
			getnstr(nmove, MOV);
			net_send(&tcpsock2 ,nmove, MOV);
		}
		else if(player[8])
		{
			net_recv(&tcpsock2 ,nmove, MOV);
		}
	}
	
	/* Client */
	else if(chess[5])
	{
		if(player[1])
		{
			net_recv(&tcpsock, nmove, MOV);	
		}
		else if(player[8])
		{	
			getnstr(nmove, MOV);	
			net_send(&tcpsock, nmove, MOV);
		}
	}
}

/*---------------------------------------------------------------------------*/

